--[[===========================================================
    TILT LOSSES MOD
    =============================================================
	2023-04: originally implemented for FS22 by Sushifresser
]]

TiltLossEvent = {};
local TiltLossEvent_mt = Class(TiltLossEvent, Event);
InitEventClass(TiltLossEvent, "TiltLossEvent");

function TiltLossEvent.emptyNew()
	local self =  Event.new(TiltLossEvent_mt);
	return self;
end

function TiltLossEvent.new(vehicle, fillUnitIndex, newVol)
	local self = TiltLossEvent.emptyNew();
	self.vehicle = vehicle;
	self.fillUnitIndex = fillUnitIndex;
	self.newVol = newVol;
	return self;
end

function TiltLossEvent:readStream(streamId, connection)
	self.vehicle = NetworkUtil.readNodeObject(streamId);
	self.fillUnitIndex = streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS);
	self.newVol = streamReadFloat32(streamId);
	self:run(connection);
end

function TiltLossEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.vehicle);
	streamWriteUIntN(streamId, self.fillUnitIndex, FillTypeManager.SEND_NUM_BITS);
	streamWriteFloat32(streamId, self.newVol);
	
end

function TiltLossEvent:run(connection)
	if not connection:getIsServer() then
		--print("[TiltLossEvent]: server")
		self.vehicle:removeLoadFromFillUnit(self.fillUnitIndex, self.newVol, true);
		g_server:broadcastEvent(self, false, connection, self.vehicle);
	else
		--print("[TiltLossEvent]: client")
		self.vehicle:removeLoadFromFillUnit(self.fillUnitIndex, self.newVol, true);
	end
end

function TiltLossEvent.sendEvent(vehicle, fillUnitIndex, newVol, noEventSend)
	if noEventSend == nil or not noEventSend then
		--print("[TiltLossEvent]: sending TiltLossEvent");
		if g_server ~= nil then
			g_server:broadcastEvent(TiltLossEvent.new(vehicle, fillUnitIndex, newVol), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(TiltLossEvent.new(vehicle, fillUnitIndex, newVol));
		end
	end


end